<script setup lang="ts">
import 'swiper/css';
import 'swiper/css/keyboard';
import 'swiper/css/navigation';
import 'swiper/css/pagination';
import { register } from 'swiper/element/bundle';
import { nextTick, onMounted, onUnmounted, ref } from 'vue';
import { useRouter } from 'vue-router'; // Importar Vue Router para la navegación

// Registrar Swiper para Vue 3
onMounted(() => {
  register();
});

// Referencia al contenedor Swiper para capturar eventos y mover slides
const swiperRef = ref<HTMLElement | null>(null);
const timer = ref<number | null>(null); // Almacena el temporizador
const delay = 10000; // Tiempo de retardo en milisegundos (10 segundos)
const isPaused = ref(false); // Estado de pausa del temporizador
const progress = ref(0); // Progreso de la barra de tiempo (0-100)
const interval = 100; // Frecuencia de actualización de la barra en milisegundos
const iframeLoaded = ref(false); // Verifica si el primer iframe se ha cargado
const currentIndex = ref(0); // Índice actual de la diapositiva

// JSON que contiene las URLs de Grafana
const grafanaPanels = ref([]); // Almacena los paneles cargados desde localStorage

// Router para manejar la navegación
const router = useRouter();

const isLoading = ref(true);

const hasData = ref(false);

// Cargar los paneles desde localStorage
const loadPanelsFromLocalStorage = () => {
  const grafanaUrl = window.GRAFANA_URI

  const storedData = localStorage.getItem('dashboards');

  if (storedData) {
    // Parseamos los datos
    const parsedData = JSON.parse(storedData);

    // Filtramos los dashboards que tienen al menos un panel con home_view: true
    grafanaPanels.value = parsedData.flatMap((dashboard: any) => {
      // Filtramos los paneles que tienen home_view: true
      const homeViewPanels = dashboard.panels.filter((panel: any) => panel.home_view === true);

      // Mapa los paneles a la URL completa para el iframe
      return homeViewPanels.map((panel: any) => ({
        url: `${grafanaUrl}${dashboard.url}?orgId=1&refresh=10s&theme=light&viewPanel=${panel.id}&kiosk`,
      }));
    });

    hasData.value = grafanaPanels.value.length > 0; // Indica si hay datos en localStorage si hay paneles filtrados
  } else {
    hasData.value = false; // No hay datos en localStorage
    console.warn('No se encontraron datos en localStorage.');
  }
};

// Función para redirigir a la página de carga de JSON
const goToLoadJson = () => {
  router.push('/load_json'); // Redirige a una ruta donde se cargue el JSON
};

// Función para pasar a la siguiente diapositiva
const goToNextSlide = () => {
  if (swiperRef.value && !isPaused.value) {
    swiperRef.value.swiper.slideNext();
  }
};

// Función para pasar a la diapositiva anterior
const goToPreviousSlide = () => {
  if (swiperRef.value && !isPaused.value) {
    swiperRef.value.swiper.slidePrev();
  }
};

// Función que se ejecuta cuando el primer iframe de Grafana se carga
const onIframeLoaded = () => {
  if (!iframeLoaded.value) {
    isLoading.value = false;
    iframeLoaded.value = true; // Marca que el primer iframe ha sido cargado
    console.log('Primer iframe cargado. Iniciando temporizador');
    startTimer(); // Inicia el temporizador solo cuando el primer iframe se haya cargado
  }
};

// Función para pausar o reanudar el temporizador al presionar espacio
const togglePause = () => {
  isPaused.value = !isPaused.value;
  if (isPaused.value) {
    if (timer.value) clearInterval(timer.value); // Si está en pausa, limpiar el temporizador
  } else {
    startTimer(); // Si no está en pausa, reiniciar el temporizador
  }
};

// Función para capturar el evento de teclado
const handleKeydown = (event: KeyboardEvent) => {
  if (event.code === 'Space') { // Si se presiona la tecla de espacio
    event.preventDefault(); // Prevenir el comportamiento por defecto (scrolling)
    togglePause(); // Pausar o reanudar el temporizador
  }
  else if (event.code === 'ArrowRight') {
    goToNextSlide(); 
  }
  else if (event.code === 'ArrowLeft') {
    goToPreviousSlide(); 
  }
};




// Función para iniciar o reiniciar el temporizador
const startTimer = () => {
  if (timer.value) clearInterval(timer.value); // Limpiar temporizador existente
  progress.value = 0; // Restablecer progreso de la barra

  const steps = delay / interval; // Número de actualizaciones de la barra
  let currentStep = 0;

  timer.value = setInterval(() => {
    if (isPaused.value) return; // No actualizar si está en pausa
    currentStep += 1;
    progress.value = (currentStep / steps) * 100; // Calcular porcentaje de progreso
    if (currentStep >= steps) {
      if (swiperRef.value.swiper.isEnd) {
        // Si estamos en la última diapositiva, después de 10 segundos volvemos a la primera
        swiperRef.value.swiper.slideTo(0, 0); // Vuelve a la primera diapositiva sin animación
      } else {
        goToNextSlide(); // Cambiar a la siguiente diapositiva
      }
      startTimer(); // Reiniciar el temporizador para la siguiente diapositiva
    }
  }, interval) as unknown as number;
};



const onSlideChange = () => {
  if (swiperRef.value) {
    currentIndex.value = swiperRef.value.swiper.realIndex; // Actualiza el índice actual 
    swiperRef.value.swiper.pagination.update(); // Actualiza la paginación en cada cambio
  }
};


// Configuración de eventos y temporizador en la carga del componente
onMounted(async () => {
  window.addEventListener('keydown', handleKeydown);
  loadPanelsFromLocalStorage(); // Cargar los paneles desde localStorage
  console.log('Grafana Panels:', grafanaPanels.value);
  nextTick(() => {
    if (swiperRef.value) {
      swiperRef.value.swiper.on('slideChange', onSlideChange); // Agregar el manejador de cambio de diapositiva
      // swiperRef.value.swiper.on('reachEnd', onReachEnd); // Escuchar cuando se llega al final
      swiperRef.value.swiper.update(); // Actualiza Swiper
      console.log('Componentes cargados, iniciando temporizador');
      
    }
  });
});

// Limpiar eventos y temporizador al desmontar el componente
onUnmounted(() => {
  if (timer.value) clearInterval(timer.value);
  window.removeEventListener('keydown', handleKeydown);
});
</script>

<template>
  <div class="swiper-wrapper">
    
    <!-- Mostrar mensaje si no hay datos en localStorage -->
    <div v-if="!hasData" class="no-data-container">
      <p>No hay datos cargados. Por favor, carga el JSON.</p>
      <VBtn @click="goToLoadJson" color="primary">
        Cargar JSON
      </VBtn>
    </div>
    <!--
    <div v-if="isLoading">
      <v-progress-circular
        indeterminate
        color="primary"
        size="64"
        class="spinner"
      ></v-progress-circular>
    </div>
    -->
    <!-- Barra de progreso inferior -->
    <div class="progress-bar">
      <div class="progress" :style="{ width: progress + '%' }"></div>
    </div>
    
    <swiper-container
      ref="swiperRef"
      :navigation="true"
      :pagination="true"
      :loop="true"
      :keyboard="true"
      class="my-swiper-container"
      space-between="30"
      slides-per-view="1"
      :looped-slides="grafanaPanels.length"       
      :loop-additional-slides="0"
      style=" position: relative; block-size: 500px;inline-size: 100%;"
    >
      <!-- Swiper Slide generados dinámicamente desde el JSON -->
      <swiper-slide
        v-for="(panel, index) in grafanaPanels"
        :key="index"
        class="swiper-slide"
      >
        <!-- Iframe de Grafana -->
        <iframe
          :src="panel.url"
          frameborder="0"
          style=" block-size: 100%;inline-size: 100%;"
          @load="onIframeLoaded"
        ></iframe>
      </swiper-slide>
    </swiper-container>

  </div>
</template>

<style scoped>
.my-swiper-container {
  block-size: 500px;
  inline-size: 100%;
}

.swiper-slide {
  display: flex;
  align-items: center;
  justify-content: center;
}

.progress-bar {
  position: absolute;
  z-index: 9;
  background-color: #e6e6e6;
  block-size: 2px;
  inline-size: 100%;
  inset-block-end: -2px;
  inset-inline-start: 0;
}

.progress {
  background-color: #4000ff;
  block-size: 100%;
  transition: inline-size 0.1s linear;
}

</style>
